/*
 *	MailPatcher.c     Version 2.0   
 *
 *      cc -Wall -O2 -s -arch m68k -arch i386 -arch hppa -arch sparc \
 *         MailPatcher.c -o MailPatcher
 *
 *      (c) 1997 Gerald Erdmann (gerald@nexttoyou.de) for NEXTOYOU
 *
 *      This utility creats a new binary of Mail.app to correct RFC 822 bug. 
 *
 *      Dieses Programm erzeugt eine neues Programmbinary von Mail.app,
 *      um dessen Header (halbwegs) RFC 822 konform zu machen.
 *
 *	Usage:  MailPatcher binary
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <libc.h>

#define ORGEXPR1  "%s.Mailer (1.%s%s)"
#define NEWEXPR1  "%s.Mailer (%s%s); "
#define LENGTH1   18

#define ORGEXPR2  "NeXT.Mailer\000Received: %s (1.%s)"
#define NEWEXPR2  "WiNG.Mailer\000Received: %s (%s); "
#define LENGTH2   31


void main (int argc, char *argv[])
{
    char  buffer[1024];
    FILE *fpin, *fpout;
    int   i, j, read, patched;

    if (argc != 2) {
        fprintf (stderr, "USAGE: MailPatcher binary\n\n");
        fprintf (stderr, "       Version 2.0 (c) by NEXTTOYOU Magazine (http://www.nexttoyou.de)\n");
        fprintf (stderr, "                          Gerald Erdmann (gerald@nexttoyou.de)\n");
        fprintf (stderr, "                          David Andel (david@nexttoyou.de)\n");
        fprintf (stderr, "                          Uli Zappe (uli@nexttoyou.de)\n");
        exit (1);
    }

    if (!(fpin = fopen (argv[1], "r"))) {
        fprintf (stderr, "MailPatcher: Kann %s nicht oeffnen!\n", argv[1]);
        exit (1);
    }
    if (!(fpout = fopen ("/tmp/MailPatcher.tmp", "w"))) {
        fprintf (stderr, "MailPatcher: Kann in /tmp nicht schreiben!\n");
        exit (1);
    }

    read = patched = 0;
    while (i = fread (buffer, sizeof (char), 1024, fpin)) {
        for (j = 0; j < i - strlen (ORGEXPR1); j++) {
            if (!bcmp (&buffer[j], ORGEXPR1, LENGTH1)) {
                fseek (fpin, read + j, SEEK_SET);
                bcopy (NEWEXPR1, &buffer[j], LENGTH1);
                patched = 1;
            }
        }
        for (j = 0; j < i - strlen (ORGEXPR2); j++) {
            if (!bcmp (&buffer[j], ORGEXPR2, LENGTH2)) {
                fseek (fpin, read + j, SEEK_SET);
                bcopy (NEWEXPR2, &buffer[j], LENGTH2);
                patched = 1;
            }
        }
        if (fwrite (buffer, sizeof (char), i, fpout) != i) {
            fprintf (stderr, "MailPatcher: Fehler beim Schreiben!\n");
            exit (10);
        }
        read += i;
        fseek (fpin, read, SEEK_SET);
    }

    fclose (fpin);
    fclose (fpout);

    if (patched) {
        sprintf (buffer, "cp %s %s.org 2>/dev/null", argv[1], argv[1]);
        if (system (buffer)) {
            printf ("MailPatcher: Keine Schreibrechte fuer %s\n", argv[1]);
            exit (10);
        }
        sprintf (buffer, "cp /tmp/MailPatcher.tmp %s", argv[1]); 
        system (buffer);
        system ("rm -f /tmp/MailPatcher.tmp");
        sprintf (buffer, "chmod 755 %s", argv[1]);
        system (buffer);
        printf ("%s gepatcht!\n", argv[1]);
    }

    exit (0);
}